#ifndef _PTOOLS_H
#define _PTOOLS_H

/*
 * pTools: Process Information Utilities
 * Stephen Oberther
 * oberther@cs.fsu.edu
 * 
 * General include file for all things general to each of
 * the pTools.
 */

#include "./ptools-pid.h"
#include "./ptools-args.h"

#define MAX_NUM_ARGS    6

/* Found in linux/include/linux/ptools.h */
struct ptools_struct {

  /* Used for pstop/prun */
  volatile long pr_prev_state;

  short pr_syscall;
  short pr_nsysarg;
  int pr_errno;
  long pr_sysarg[MAX_NUM_ARGS];
};




/*
 * Error value set by ptools library functions to pass
 * error information to the caller.  Same idea as errno
 */
extern int ptools_errno;

/*
 * String containing the original argument processed
 * by ptools_arg_setup().  If an error is returned by the
 * argument processing code (ie a call to ptools_arg_next())
 * this will point to the argument that caused the error.
 */
extern char *ptools_arg_str;  /* NEVER free() this pointer */
#endif
