#ifndef _SIGACT_H
#define _SIGACT_H

/*
 * pTools: Process Information Utilities
 * Stephen Oberther
 * oberther@cs.fsu.edu
 *
 * Sets up data structures needed for reading the proc/pid/sigact
 * file added for psig.
 */

#define SA_RESTORER 0x04000000
#define WP_SIG_MASK          2  /* Words Per Signal Mask */

/* Based off i386 include/asm-i386/signal.h
 * kernel sigaction structure...need to work
 * around this :(
 *
 * 3-20-2002:  Can include asm/signal.h and #define kernel
 * in source code so we don't need to declare and update
 * this structure.
 */

struct kern_sigaction {
  __sighandler_t handler;
  unsigned long flags;
  void (*restorer) (void);
  /* unsigned long mask[WP_SIG_MASK]; */
  unsigned long long mask;
};

#endif
