/*
 * blkconv.c
 * Stephen Oberther
 *
 *
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>


unsigned long long ConvertMask(char *str) {
  int cnt, shift;
  char c;
  unsigned long long tmp, ret = 0;

  for(cnt = 0; cnt < strlen(str); cnt++) {
    c = tolower(str[cnt]);
    if (isdigit(c))
      tmp = c - '0';

    else if (isalpha(c)) {
      if ( (c < 'a') || (c > 'f') )
	return -1;
      tmp = c - 'a' + 10;
    }
    shift = 60 - (4 * cnt);
    
    ret |= tmp << shift;
  }

  return ret;
}

int main(int argc, char **argv) {

  if (argc <= 1) {
    fprintf(stderr, "%s <text signal mask>\n", *argv);
    return -1;
  }

  printf("Signal Mask: %s\n", argv[1]);

  printf("\t     %016Lx\n", ConvertMask(argv[1]));

}
